/* Example 1.2.line.c: scan-convert random generated lines (rounding) */
// by Jim X. Chen; September, 2000

#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>

int Height=400, Width=400;


void line(int x0,int y0,int xn,int yn)
{ // scan-convert an integer line with slope -1<m<1
    int x;
	float m, y;

    m = (float) (yn-y0)/(xn-x0);

    x=x0; y= y0;
 
    while (x<xn+1) { 
        // write a pixel into framebuffer	
		glBegin(GL_POINTS);
			glVertex2i (x,(int) y);
		glEnd();

		x++; y+=m;/* next pixel's position */
    }
}


void display(void)
{
	int x0, y0, xn, yn;

	// generate a random line with x0<xn;
	x0 = (rand() % Width)/2; 
	y0 = rand() % Height; 
	xn = x0 + (rand() % Width)/2; 
	yn = rand() % Height; 

	// draw green lines
	glColor3f(0, 1, 0);
	line(x0, y0, xn, yn);
	glFlush();
}


static void Reshape(int w, int h)
{
	// set the background color to black
    glClearColor (0.0, 0.0, 0.0, 0.0);
    glClear(GL_COLOR_BUFFER_BIT);

    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();

    glOrtho(0, Width, 0, Height, -1.0, 1.0); 
}


int main(int argc, char **argv)
{
    glutInit(&argc, argv);
 	glutInitDisplayMode(GLUT_SINGLE);
    glutInitWindowSize(Width, Height);
    glutCreateWindow("Example 1.2.line.c: randomly generated lines");

    glutReshapeFunc(Reshape); 
    glutDisplayFunc(display);
    glutIdleFunc(display);

    glutMainLoop();
}