/* Example 1.4.line.c: scan-convert randomly generated lines with antialiasing */
// by Jim X. Chen; September, 2000

#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>


#define ESC 27
#define SPACE 32
int Height=400, Width=400;
float r, g, b;


void swapd(int *a, int *b)
{
    int tmp;

       tmp=*a;*a=*b;*b=tmp;
}


void writepixel(int x, int y, int flag)
{ 
	
	glBegin(GL_POINTS);
		if (flag==0) glVertex2i (x,y);
		else if (flag==1) glVertex2i (y,x);
		else if (flag==10) glVertex2i (x,-y);
		else if (flag==11) glVertex2i (y,-x);
	glEnd();
}

void IntensifyPixel(int x,int y, double D, int flag)
{
	float d, r1, g1, b1;

	if (D<0) d = -D; else d = D;

	r1=r*(1-d/2.5); g1=g*(1-d/2.5); b1=b*(1-d/2.5); 


   	glColor3f(r1, g1, b1);

	writepixel(x,y,flag);
}
	 


void antialiasedLine(int x0,int y0,int xn,int yn)
{ /* scan-convert a 3 pixel wide antialiased line */
	int dx, dy, incrE, incrNE, d, x, y, flag = 0; 
	double D=0, sin_a, cos_a, sin_cos_a, Denom;

	if (xn<x0) { swapd(&x0,&xn); swapd(&y0,&yn); }
	if (yn<y0) { y0 = -y0; yn = -yn; flag=10; }

	dy=yn-y0; dx=xn-x0; 

	if (dx<dy) { swapd(&x0,&y0); swapd(&xn,&yn); swapd(&dy,&dx); flag++;}

	x=x0; y=y0; 
	d=2*dy-dx; incrE=2*dy; incrNE=2*(dy-dx);

	Denom = sqrt(dx*dx + dy*dy);
	sin_a = dy/Denom; cos_a = dx/Denom; sin_cos_a = sin_a - cos_a;


	while (x<xn+1) { 
		IntensifyPixel(x,y,D,flag); 
		IntensifyPixel(x,y+1,D-cos_a,flag); 
		IntensifyPixel(x,y-1,D+cos_a,flag); 
		IntensifyPixel(x,y+2,D-2*cos_a,flag); 
		IntensifyPixel(x,y-2,D+2*cos_a,flag); 
		
		x++; /* consider next pixel */
		if (d<=0) { D+=sin_a; d+=incrE; }
    		else { D+=sin_cos_a; y++; d+=incrNE; };

	}
}


void display(void)
{
	int x0, y0, xn, yn;

	x0 = (rand() % Width) - Width/2; 
	y0 = (rand() % Height) - Height/2; 
	xn = (rand() % Width) - Width/2; 
	yn = (rand() % Height) - Height/2; 

	r=(float)((rand() % 9))/8;
	g=(float)((rand() % 9))/8;
	b=(float)((rand() % 9))/8;
   	glColor3f(r, g, b);

	antialiasedLine(x0, y0, xn, yn);
	glFlush();
}



static void Reshape(int w, int h)
{
    glClearColor (0.0, 0.0, 0.0, 1.0);
    glClear(GL_COLOR_BUFFER_BIT);

	Width = w; Height = h; 

    glViewport (0, 0, Width, Height);

    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    glOrtho(-Width/2, Width/2, -Height/2, Height/2, -1.0, 1.0); 
}



static void Key(unsigned char key, int x, int y)
{ 
    switch (key) {
      case ESC:
			exit(0);
	  case SPACE: 
			glutIdleFunc(NULL); display();
			break; 
	  default: 
			glutIdleFunc(display); 
    }
}


int main(int argc, char **argv)
{
    glutInit(&argc, argv);
 	glutInitDisplayMode(GLUT_SINGLE);
    glutInitWindowSize(Width, Height);
    glutCreateWindow("Example 1.4.line.c: press SPACE & stretch the window");

    glutKeyboardFunc(Key);
    glutReshapeFunc(Reshape); 
    glutDisplayFunc(display);
    glutIdleFunc(display);

    glutMainLoop();
}


